From e74685eedf5659cb452d0a86b965a2d3adbc5964 Mon Sep 17 00:00:00 2001
From: Gareth Williams <garethw@codeaurora.org>
Date: Wed, 13 May 2015 10:08:15 +0100
Subject: [PATCH 2/3] [qca-nss-ecm] Add PCC Classifier

Add PCC Classifier

Change-Id: Ib8bbcd312236778da7a032491a74d1a0104f5617
Signed-off-by: Gareth Williams <garethw@codeaurora.org>
---
 Makefile                    |   10 +
 ecm_classifier.h            |    3 +
 ecm_classifier_pcc.c        | 1210 +++++++++++++++++++++++++++++++++++++++++++
 ecm_classifier_pcc.h        |   18 +
 ecm_classifier_pcc_public.h |   69 +++
 ecm_front_end_ipv4.c        |   17 +
 ecm_front_end_ipv6.c        |   17 +
 ecm_init.c                  |   21 +
 8 files changed, 1365 insertions(+)
 create mode 100644 ecm_classifier_pcc.c
 create mode 100644 ecm_classifier_pcc.h
 create mode 100644 ecm_classifier_pcc_public.h

diff --git a/Makefile b/Makefile
index cca6e5a..25f43ea 100755
--- a/Makefile
+++ b/Makefile
@@ -102,12 +102,22 @@ ecm-$(ECM_CLASSIFIER_HYFI_ENABLE) += ecm_classifier_hyfi.o
 ccflags-$(ECM_CLASSIFIER_HYFI_ENABLE) += -DECM_CLASSIFIER_HYFI_ENABLE
 
 # #############################################################################
+# Define ECM_CLASSIFIER_PCC_ENABLE=y in order to enable
+# the Parental Controls subsystem classifier in ECM. Currently disabled until
+# customers require it / if they need to integrate their Parental Controls with it.
+# #############################################################################
+ECM_CLASSIFIER_PCC_ENABLE=y
+ecm-$(ECM_CLASSIFIER_PCC_ENABLE) += ecm_classifier_pcc.o
+ccflags-$(ECM_CLASSIFIER_PCC_ENABLE) += -DECM_CLASSIFIER_PCC_ENABLE
+
+# #############################################################################
 # Debug flags, set these to = 0 if you want to disable all debugging for that
 # file.
 # By turning off debugs you gain maximum ECM performance.
 # #############################################################################
 ccflags-y += -DECM_CLASSIFIER_DSCP_DEBUG_LEVEL=1
 ccflags-y += -DECM_CLASSIFIER_HYFI_DEBUG_LEVEL=1
+ccflags-y += -DECM_CLASSIFIER_PCC_DEBUG_LEVEL=1
 ccflags-y += -DECM_CLASSIFIER_NL_DEBUG_LEVEL=1
 ccflags-y += -DECM_CLASSIFIER_DEFAULT_DEBUG_LEVEL=1
 ccflags-y += -DECM_DB_DEBUG_LEVEL=1
diff --git a/ecm_classifier.h b/ecm_classifier.h
index 7d43b93..e5db661 100644
--- a/ecm_classifier.h
+++ b/ecm_classifier.h
@@ -31,6 +31,9 @@ enum ecm_classifier_types {
 #ifdef ECM_CLASSIFIER_NL_ENABLE
 	ECM_CLASSIFIER_TYPE_NL,			/* Provides netlink interface */
 #endif
+#ifdef ECM_CLASSIFIER_PCC_ENABLE
+	ECM_CLASSIFIER_TYPE_PCC,		/* Parental control subsystem support classifier */
+#endif
 	ECM_CLASSIFIER_TYPES,			/* MUST BE LAST */
 };
 typedef enum ecm_classifier_types ecm_classifier_type_t;
diff --git a/ecm_classifier_pcc.c b/ecm_classifier_pcc.c
new file mode 100644
index 0000000..2c9ec73
--- /dev/null
+++ b/ecm_classifier_pcc.c
@@ -0,0 +1,1210 @@
+/*
+ **************************************************************************
+ * Copyright (c) 2015, The Linux Foundation.  All rights reserved.
+ * Permission to use, copy, modify, and/or distribute this software for
+ * any purpose with or without fee is hereby granted, provided that the
+ * above copyright notice and this permission notice appear in all copies.
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
+ * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ **************************************************************************
+ */
+
+/*
+ * Parental Controls Classifier.
+ * While not implementing parental controls feature itself.
+ * This module provides an interface for customer parental controls systems to interract with the ECM.
+ * This ensures that acceleration will not interfere with parental controls logics, especially DPI.
+ */
+
+#include <linux/version.h>
+#include <linux/types.h>
+#include <linux/ip.h>
+#include <linux/tcp.h>
+#include <linux/module.h>
+#include <linux/skbuff.h>
+#include <linux/icmp.h>
+#include <linux/sysctl.h>
+#include <linux/kthread.h>
+#include <linux/device.h>
+#include <linux/fs.h>
+#include <linux/pkt_sched.h>
+#include <linux/string.h>
+#include <linux/ctype.h>
+#include <net/route.h>
+#include <net/ip.h>
+#include <net/tcp.h>
+#include <asm/unaligned.h>
+#include <asm/uaccess.h>	/* for put_user */
+#include <net/ipv6.h>
+#include <linux/inet.h>
+#include <linux/in.h>
+#include <linux/udp.h>
+#include <linux/tcp.h>
+
+#include <linux/netfilter_ipv4.h>
+#include <linux/netfilter_bridge.h>
+#include <net/netfilter/nf_conntrack.h>
+#include <net/netfilter/nf_conntrack_helper.h>
+#include <net/netfilter/nf_conntrack_l4proto.h>
+#include <net/netfilter/nf_conntrack_l3proto.h>
+#include <net/netfilter/nf_conntrack_core.h>
+#include <net/netfilter/ipv4/nf_conntrack_ipv4.h>
+#include <net/netfilter/ipv4/nf_defrag_ipv4.h>
+
+/*
+ * Debug output levels
+ * 0 = OFF
+ * 1 = ASSERTS / ERRORS
+ * 2 = 1 + WARN
+ * 3 = 2 + INFO
+ * 4 = 3 + TRACE
+ */
+#define DEBUG_LEVEL ECM_CLASSIFIER_PCC_DEBUG_LEVEL
+
+#include <nss_api_if.h>
+
+#include "ecm_types.h"
+#include "ecm_db_types.h"
+#include "ecm_tracker.h"
+#include "ecm_classifier.h"
+#include "ecm_front_end_types.h"
+#include "ecm_tracker_datagram.h"
+#include "ecm_tracker_udp.h"
+#include "ecm_tracker_tcp.h"
+#include "ecm_db.h"
+#include "ecm_classifier_pcc.h"
+#include "ecm_classifier_pcc_public.h"
+
+/*
+ * Magic numbers
+ */
+#define ECM_CLASSIFIER_PCC_INSTANCE_MAGIC 0x2351
+
+/*
+ * struct ecm_classifier_pcc_instance
+ * 	State per connection for PCC classifier
+ */
+struct ecm_classifier_pcc_instance {
+	struct ecm_classifier_instance base;			/* Base type */
+
+	ecm_classifier_pcc_result_t accel_permit_state;		/* Permission state for acceleration */
+	uint32_t ci_serial;					/* RO: Serial of the connection */
+	long process_jiffies_last;				/* Rate limiting the calls to the registrant */
+	uint32_t reg_calls_to;					/* #calls to registrant */
+	uint32_t reg_calls_from;				/* #calls from registrant */
+
+	struct ecm_classifier_process_response process_response;
+								/* Last process response computed */
+	int refs;						/* Integer to trap we never go negative */
+#if (DEBUG_LEVEL > 0)
+	uint16_t magic;
+#endif
+};
+
+static spinlock_t ecm_classifier_pcc_lock;			/* Concurrency control SMP access */
+static int ecm_classifier_pcc_count = 0;			/* Tracks number of instances allocated */
+static struct ecm_classifier_pcc_registrant *ecm_classifier_registrant = NULL;
+								/* Singleton Parent Controls code */
+
+/*
+ * Operational control
+ */
+static bool ecm_classifier_pcc_enabled = false;			/* Enable / disable state of the classifier function */
+
+/*
+ * System device linkage
+ */
+static struct device ecm_classifier_pcc_dev;
+
+/*
+ * ecm_classifier_pcc_register()
+ *	Register a new PCC module.
+ *
+ */
+int ecm_classifier_pcc_register(struct ecm_classifier_pcc_registrant *r)
+{
+	/*
+	 * Hold the module of the registrant
+	 */
+	if (!try_module_get(r->this_module)) {
+		return -ESHUTDOWN;
+	}
+
+	/*
+	 * Hold the registrant we have been given for our purposes.
+	 */
+	r->ref(r);
+
+	spin_lock_bh(&ecm_classifier_pcc_lock);
+	if (ecm_classifier_registrant) {
+		spin_unlock_bh(&ecm_classifier_pcc_lock);
+		DEBUG_WARN("Registrant already\n");
+		module_put(r->this_module);
+		r->deref(r);
+		return -EALREADY;
+	}
+	ecm_classifier_registrant = r;
+	ecm_classifier_pcc_enabled = true;
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+
+	/*
+	 * Force a re-generation of all connections
+	 */
+	ecm_db_classifier_generation_change();
+	return 0;
+}
+EXPORT_SYMBOL(ecm_classifier_pcc_register);
+
+/*
+ * ecm_classifier_pcc_unregister_begin()
+ *	Begin unregistration process
+ */
+void ecm_classifier_pcc_unregister_begin(struct ecm_classifier_pcc_registrant *r)
+{
+	struct ecm_classifier_pcc_registrant *reg;
+
+	spin_lock_bh(&ecm_classifier_pcc_lock);
+	reg = ecm_classifier_registrant;
+	if (!reg) {
+		spin_unlock_bh(&ecm_classifier_pcc_lock);
+		DEBUG_WARN("No Registrant\n");
+		return;
+	}
+	if (reg != r) {
+		spin_unlock_bh(&ecm_classifier_pcc_lock);
+		DEBUG_WARN("Unexpected registrant, given: %p, expecting: %p\n", r, reg);
+		return;
+	}
+
+	ecm_classifier_registrant = NULL;
+	ecm_classifier_pcc_enabled = false;
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+
+	/*
+	 * Release our ref upon the registrant that we took when it was registered
+	 */
+	reg->deref(reg);
+	module_put(reg->this_module);
+
+	/*
+	 * Force a re-generation of all connections
+	 */
+	ecm_db_classifier_generation_change();
+}
+EXPORT_SYMBOL(ecm_classifier_pcc_unregister_begin);
+
+/*
+ * ecm_classifier_pcc_permit_accel_v4()
+ *	Permit acceleration.
+ *
+ * Big endian parameters apart from protocol
+ */
+void ecm_classifier_pcc_permit_accel_v4(uint8_t *src_mac, __be32 src_ip, int src_port, uint8_t *dest_mac, __be32 dest_ip, int dest_port, int protocol)
+{
+	ip_addr_t ecm_src_ip;
+	ip_addr_t ecm_dest_ip;
+	struct ecm_db_connection_instance *ci;
+	struct ecm_classifier_instance *classi;
+	struct ecm_classifier_pcc_instance *pcci;
+
+	/*
+	 * Look up ECM connection from the given tuple
+	 */
+	src_port = ntohs(src_port);
+	dest_port = ntohs(dest_port);
+	ECM_NIN4_ADDR_TO_IP_ADDR(ecm_src_ip, src_ip);
+	ECM_NIN4_ADDR_TO_IP_ADDR(ecm_dest_ip, dest_ip);
+
+	{
+		char src_ip_str[40];
+		char dest_ip_str[40];
+
+		ecm_ip_addr_to_string(src_ip_str, ecm_src_ip);
+		ecm_ip_addr_to_string(dest_ip_str, ecm_dest_ip);
+
+		DEBUG_INFO("Permit Accel v4, lookup connection using \n"
+				"Protocol: %d\n"
+				"src: %s:%d\n"
+				"dest: %s:%d\n",
+				protocol,
+				src_ip_str, src_port,
+				dest_ip_str, dest_port);
+	}
+
+	ci = ecm_db_connection_find_and_ref(ecm_src_ip, ecm_dest_ip, protocol, src_port, dest_port);
+	if (!ci) {
+		DEBUG_TRACE("Not found\n");
+		return;
+	}
+
+	/*
+	 * Get the PCC classifier
+	 */
+	classi = ecm_db_connection_assigned_classifier_find_and_ref(ci, ECM_CLASSIFIER_TYPE_PCC);
+	if (!classi) {
+		DEBUG_TRACE("No PCC classi\n");
+		ecm_db_connection_deref(ci);
+		return;
+	}
+	pcci = (struct ecm_classifier_pcc_instance *)classi;
+	DEBUG_CHECK_MAGIC(pcci, ECM_CLASSIFIER_PCC_INSTANCE_MAGIC, "%p: magic failed", pcci);
+
+	/*
+	 * Set the permitted accel state to PERMITTED
+	 * NOTE: When we next see activity on this connection it shall be accelerated (save depending on other classifiers decisions too).
+	 */
+	spin_lock_bh(&ecm_classifier_pcc_lock);
+	pcci->accel_permit_state = ECM_CLASSIFIER_PCC_RESULT_PERMITTED;
+	pcci->process_response.relevance = ECM_CLASSIFIER_RELEVANCE_YES;
+	pcci->process_response.process_actions = ECM_CLASSIFIER_PROCESS_ACTION_ACCEL_MODE;
+	pcci->process_response.accel_mode = ECM_CLASSIFIER_ACCELERATION_MODE_ACCEL;
+	pcci->reg_calls_from++;
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+
+	classi->deref(classi);
+	ecm_db_connection_deref(ci);
+}
+EXPORT_SYMBOL(ecm_classifier_pcc_permit_accel_v4);
+
+/*
+ * ecm_classifier_pcc_permit_accel_v6()
+ *	Permit acceleration
+ *
+ * Big endian parameters apart from protocol.
+ *
+ * NOTE: If IPv6 is not supported in ECM this function must still exist as a stub to avoid compilation problems for registrants.
+ */
+void ecm_classifier_pcc_permit_accel_v6(uint8_t *src_mac, struct in6_addr *src_ip, int src_port, uint8_t *dest_mac, struct in6_addr *dest_ip, int dest_port, int protocol)
+{
+	struct in6_addr in6;
+	ip_addr_t ecm_src_ip;
+	ip_addr_t ecm_dest_ip;
+	struct ecm_db_connection_instance *ci;
+	struct ecm_classifier_instance *classi;
+	struct ecm_classifier_pcc_instance *pcci;
+
+	/*
+	 * Look up ECM connection from the given tuple
+	 */
+	src_port = ntohs(src_port);
+	dest_port = ntohs(dest_port);
+	in6 = *src_ip;
+	ECM_NIN6_ADDR_TO_IP_ADDR(ecm_src_ip, in6);
+	in6 = *dest_ip;
+	ECM_NIN6_ADDR_TO_IP_ADDR(ecm_dest_ip, in6);
+
+	{
+		char src_ip_str[40];
+		char dest_ip_str[40];
+
+		ecm_ip_addr_to_string(src_ip_str, ecm_src_ip);
+		ecm_ip_addr_to_string(dest_ip_str, ecm_dest_ip);
+
+		DEBUG_INFO("Permit Accel v6, lookup connection using \n"
+				"Protocol: %d\n"
+				"src: %s:%d\n"
+				"dest: %s:%d\n",
+				protocol,
+				src_ip_str, src_port,
+				dest_ip_str, dest_port);
+	}
+
+	ci = ecm_db_connection_find_and_ref(ecm_src_ip, ecm_dest_ip, protocol, src_port, dest_port);
+	if (!ci) {
+		DEBUG_TRACE("Not found\n");
+		return;
+	}
+
+	/*
+	 * Get the PCC classifier
+	 */
+	classi = ecm_db_connection_assigned_classifier_find_and_ref(ci, ECM_CLASSIFIER_TYPE_PCC);
+	if (!classi) {
+		DEBUG_TRACE("No PCC classi\n");
+		ecm_db_connection_deref(ci);
+		return;
+	}
+	pcci = (struct ecm_classifier_pcc_instance *)classi;
+	DEBUG_CHECK_MAGIC(pcci, ECM_CLASSIFIER_PCC_INSTANCE_MAGIC, "%p: magic failed", pcci);
+
+	/*
+	 * Set the permitted accel state to PERMITTED
+	 * NOTE: When we next see activity on this connection it shall be accelerated (save depending on other classifiers decisions too).
+	 */
+	spin_lock_bh(&ecm_classifier_pcc_lock);
+	pcci->accel_permit_state = ECM_CLASSIFIER_PCC_RESULT_PERMITTED;
+	pcci->process_response.relevance = ECM_CLASSIFIER_RELEVANCE_YES;
+	pcci->process_response.process_actions = ECM_CLASSIFIER_PROCESS_ACTION_ACCEL_MODE;
+	pcci->process_response.accel_mode = ECM_CLASSIFIER_ACCELERATION_MODE_ACCEL;
+	pcci->reg_calls_from++;
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+
+	classi->deref(classi);
+	ecm_db_connection_deref(ci);
+}
+EXPORT_SYMBOL(ecm_classifier_pcc_permit_accel_v6);
+
+/*
+ * ecm_classifier_pcc_deny_accel_v4()
+ *	Deny acceleration
+ */
+void ecm_classifier_pcc_deny_accel_v4(uint8_t *src_mac, __be32 src_ip, int src_port, uint8_t *dest_mac, __be32 dest_ip, int dest_port, int protocol)
+{
+	ip_addr_t ecm_src_ip;
+	ip_addr_t ecm_dest_ip;
+	struct ecm_db_connection_instance *ci;
+	struct ecm_classifier_instance *classi;
+	struct ecm_classifier_pcc_instance *pcci;
+	struct ecm_front_end_connection_instance *feci;
+
+	/*
+	 * Look up ECM connection from the given tuple
+	 */
+	src_port = ntohs(src_port);
+	dest_port = ntohs(dest_port);
+	ECM_NIN4_ADDR_TO_IP_ADDR(ecm_src_ip, src_ip);
+	ECM_NIN4_ADDR_TO_IP_ADDR(ecm_dest_ip, dest_ip);
+
+	{
+		char src_ip_str[40];
+		char dest_ip_str[40];
+
+		ecm_ip_addr_to_string(src_ip_str, ecm_src_ip);
+		ecm_ip_addr_to_string(dest_ip_str, ecm_dest_ip);
+
+		DEBUG_INFO("Deny Accel v4, lookup connection using \n"
+				"Protocol: %d\n"
+				"src: %s:%d\n"
+				"dest: %s:%d\n",
+				protocol,
+				src_ip_str, src_port,
+				dest_ip_str, dest_port);
+	}
+
+	ci = ecm_db_connection_find_and_ref(ecm_src_ip, ecm_dest_ip, protocol, src_port, dest_port);
+	if (!ci) {
+		DEBUG_TRACE("Not found\n");
+		return;
+	}
+
+	/*
+	 * Get the PCC classifier
+	 */
+	classi = ecm_db_connection_assigned_classifier_find_and_ref(ci, ECM_CLASSIFIER_TYPE_PCC);
+	if (!classi) {
+		DEBUG_TRACE("No PCC classi\n");
+		ecm_db_connection_deref(ci);
+		return;
+	}
+	pcci = (struct ecm_classifier_pcc_instance *)classi;
+	DEBUG_CHECK_MAGIC(pcci, ECM_CLASSIFIER_PCC_INSTANCE_MAGIC, "%p: magic failed", pcci);
+
+	/*
+	 * Set the permitted accel state to DENIED
+	 * NOTE: When we next see activity on this connection it shall be accelerated (save depending on other classifiers decisions too).
+	 */
+	spin_lock_bh(&ecm_classifier_pcc_lock);
+	pcci->accel_permit_state = ECM_CLASSIFIER_PCC_RESULT_DENIED;
+	pcci->process_response.relevance = ECM_CLASSIFIER_RELEVANCE_YES;
+	pcci->process_response.process_actions = ECM_CLASSIFIER_PROCESS_ACTION_ACCEL_MODE;
+	pcci->process_response.accel_mode = ECM_CLASSIFIER_ACCELERATION_MODE_NO;
+	pcci->reg_calls_from++;
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+
+	/*
+	 * Get the front end and issue a deceleration
+	 * If the connection is not accelerated anyway this will have no effect
+	 */
+	feci = ecm_db_connection_front_end_get_and_ref(ci);
+	feci->decelerate(feci);
+	feci->deref(feci);
+
+	classi->deref(classi);
+	ecm_db_connection_deref(ci);
+}
+EXPORT_SYMBOL(ecm_classifier_pcc_deny_accel_v4);
+
+/*
+ * ecm_classifier_pcc_deny_accel_v6()
+ *	Deny acceleration
+ *
+ * NOTE: If IPv6 is not supported in ECM this function must still exist as a stub to avoid compilation problems for registrants.
+ */
+void ecm_classifier_pcc_deny_accel_v6(uint8_t *src_mac, struct in6_addr *src_ip, int src_port, uint8_t *dest_mac, struct in6_addr *dest_ip, int dest_port, int protocol)
+{
+	struct in6_addr in6;
+	ip_addr_t ecm_src_ip;
+	ip_addr_t ecm_dest_ip;
+	struct ecm_db_connection_instance *ci;
+	struct ecm_classifier_instance *classi;
+	struct ecm_classifier_pcc_instance *pcci;
+	struct ecm_front_end_connection_instance *feci;
+
+	/*
+	 * Look up ECM connection from the given tuple
+	 */
+	src_port = ntohs(src_port);
+	dest_port = ntohs(dest_port);
+	in6 = *src_ip;
+	ECM_NIN6_ADDR_TO_IP_ADDR(ecm_src_ip, in6);
+	in6 = *dest_ip;
+	ECM_NIN6_ADDR_TO_IP_ADDR(ecm_dest_ip, in6);
+
+	{
+		char src_ip_str[40];
+		char dest_ip_str[40];
+
+		ecm_ip_addr_to_string(src_ip_str, ecm_src_ip);
+		ecm_ip_addr_to_string(dest_ip_str, ecm_dest_ip);
+
+		DEBUG_INFO("Deny Accel v6, lookup connection using \n"
+				"Protocol: %d\n"
+				"src: %s:%d\n"
+				"dest: %s:%d\n",
+				protocol,
+				src_ip_str, src_port,
+				dest_ip_str, dest_port);
+	}
+
+	ci = ecm_db_connection_find_and_ref(ecm_src_ip, ecm_dest_ip, protocol, src_port, dest_port);
+	if (!ci) {
+		DEBUG_TRACE("Not found\n");
+		return;
+	}
+
+	/*
+	 * Get the PCC classifier
+	 */
+	classi = ecm_db_connection_assigned_classifier_find_and_ref(ci, ECM_CLASSIFIER_TYPE_PCC);
+	if (!classi) {
+		DEBUG_TRACE("No PCC classi\n");
+		ecm_db_connection_deref(ci);
+		return;
+	}
+	pcci = (struct ecm_classifier_pcc_instance *)classi;
+	DEBUG_CHECK_MAGIC(pcci, ECM_CLASSIFIER_PCC_INSTANCE_MAGIC, "%p: magic failed", pcci);
+
+	/*
+	 * Set the permitted accel state to DENIED
+	 * NOTE: When we next see activity on this connection it shall be accelerated (save depending on other classifiers decisions too).
+	 */
+	spin_lock_bh(&ecm_classifier_pcc_lock);
+	pcci->accel_permit_state = ECM_CLASSIFIER_PCC_RESULT_DENIED;
+	pcci->process_response.relevance = ECM_CLASSIFIER_RELEVANCE_YES;
+	pcci->process_response.process_actions = ECM_CLASSIFIER_PROCESS_ACTION_ACCEL_MODE;
+	pcci->process_response.accel_mode = ECM_CLASSIFIER_ACCELERATION_MODE_NO;
+	pcci->reg_calls_from++;
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+
+	/*
+	 * Get the front end and issue a deceleration
+	 * If the connection is not accelerated anyway this will have no effect
+	 */
+	feci = ecm_db_connection_front_end_get_and_ref(ci);
+	feci->decelerate(feci);
+	feci->deref(feci);
+
+	classi->deref(classi);
+	ecm_db_connection_deref(ci);
+}
+EXPORT_SYMBOL(ecm_classifier_pcc_deny_accel_v6);
+
+/*
+ * ecm_classifier_pcc_unregister_force()
+ *	Unregister the registrant, if any
+ */
+static void ecm_classifier_pcc_unregister_force(struct ecm_classifier_pcc_instance *pcci)
+{
+	struct ecm_classifier_pcc_registrant *reg;
+
+	spin_lock_bh(&ecm_classifier_pcc_lock);
+	reg = ecm_classifier_registrant;
+	if (!reg) {
+		spin_unlock_bh(&ecm_classifier_pcc_lock);
+		return;
+	}
+	ecm_classifier_registrant = NULL;
+	ecm_classifier_pcc_enabled = false;
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+
+	/*
+	 * Release our ref upon the registrant that we took when it was registered
+	 */
+	DEBUG_INFO("Force unregistration of: %p\n", reg);
+	reg->deref(reg);
+
+	/*
+	 * Release hold on registrant module
+	 */
+	module_put(reg->this_module);
+
+	/*
+	 * Force a re-generation of all connections
+	 */
+	ecm_db_classifier_generation_change();
+}
+
+/*
+ * _ecm_classifier_pcc_ref()
+ *	Ref
+ */
+static void _ecm_classifier_pcc_ref(struct ecm_classifier_pcc_instance *pcci)
+{
+	pcci->refs++;
+	DEBUG_TRACE("%p: pcci ref %d\n", pcci, pcci->refs);
+	DEBUG_ASSERT(pcci->refs > 0, "%p: ref wrap\n", pcci);
+}
+
+/*
+ * ecm_classifier_pcc_ref()
+ *	Ref
+ */
+static void ecm_classifier_pcc_ref(struct ecm_classifier_instance *ci)
+{
+	struct ecm_classifier_pcc_instance *pcci;
+	pcci = (struct ecm_classifier_pcc_instance *)ci;
+
+	DEBUG_CHECK_MAGIC(pcci, ECM_CLASSIFIER_PCC_INSTANCE_MAGIC, "%p: magic failed", pcci);
+	spin_lock_bh(&ecm_classifier_pcc_lock);
+	_ecm_classifier_pcc_ref(pcci);
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+}
+
+/*
+ * ecm_classifier_pcc_deref()
+ *	Deref
+ */
+static int ecm_classifier_pcc_deref(struct ecm_classifier_instance *ci)
+{
+	struct ecm_classifier_pcc_instance *pcci;
+	pcci = (struct ecm_classifier_pcc_instance *)ci;
+
+	DEBUG_CHECK_MAGIC(pcci, ECM_CLASSIFIER_PCC_INSTANCE_MAGIC, "%p: magic failed", pcci);
+	spin_lock_bh(&ecm_classifier_pcc_lock);
+	pcci->refs--;
+	DEBUG_ASSERT(pcci->refs >= 0, "%p: refs wrapped\n", pcci);
+	DEBUG_TRACE("%p: Parental Controls classifier deref %d\n", pcci, pcci->refs);
+	if (pcci->refs) {
+		int refs = pcci->refs;
+		spin_unlock_bh(&ecm_classifier_pcc_lock);
+		return refs;
+	}
+
+	/*
+	 * Object to be destroyed
+	 */
+	ecm_classifier_pcc_count--;
+	DEBUG_ASSERT(ecm_classifier_pcc_count >= 0, "%p: ecm_classifier_pcc_count wrap\n", pcci);
+
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+
+	/*
+	 * Final
+	 */
+	DEBUG_INFO("%p: Final Parental Controls classifier instance\n", pcci);
+	kfree(pcci);
+
+	return 0;
+}
+
+/*
+ * ecm_classifier_pcc_process()
+ *	Process new packet
+ *
+ * NOTE: This function would only ever be called if all other classifiers have failed.
+ */
+static void ecm_classifier_pcc_process(struct ecm_classifier_instance *aci, ecm_tracker_sender_type_t sender,
+									struct ecm_tracker_ip_header *ip_hdr, struct sk_buff *skb,
+									struct ecm_classifier_process_response *process_response)
+{
+	struct ecm_classifier_pcc_instance *pcci = (struct ecm_classifier_pcc_instance *)aci;
+	ecm_classifier_pcc_result_t accel_permit_state;
+	ecm_classifier_pcc_result_t reg_result;
+	struct ecm_db_connection_instance *ci;
+	long jiffies_now;
+	int ip_version;
+	uint8_t src_mac[ETH_ALEN];
+	uint8_t dest_mac[ETH_ALEN];
+	int protocol;
+	int src_port;
+	int dst_port;
+	ip_addr_t src_ip;
+	ip_addr_t dst_ip;
+	struct ecm_classifier_pcc_registrant *registrant;
+
+	DEBUG_CHECK_MAGIC(pcci, ECM_CLASSIFIER_PCC_INSTANCE_MAGIC, "%p: invalid state magic\n", pcci);
+
+	/*
+	 * Get connection
+	 */
+	ci = ecm_db_connection_serial_find_and_ref(pcci->ci_serial);
+	if (!ci) {
+		/*
+		 * Connection has gone from under us
+		 */
+		spin_lock_bh(&ecm_classifier_pcc_lock);
+		goto not_relevant;
+	}
+
+	/*
+	 * Early detection of DNS server port
+	 */
+	dst_port = ecm_db_connection_to_port_get(ci);
+
+	spin_lock_bh(&ecm_classifier_pcc_lock);
+
+	/*
+	 * Not relevant to the connection if not enabled.
+	 */
+	if (unlikely(!ecm_classifier_pcc_enabled)) {
+		/*
+		 * Not relevant.
+		 */
+		goto not_relevant;
+	}
+
+	/*
+	 * What is our acceleration permit state?
+	 * If it is something other than ECM_CLASSIFIER_PCC_RESULT_NOT_YET then we have a definitive result already.
+	 */
+	accel_permit_state = pcci->accel_permit_state;
+	if (accel_permit_state != ECM_CLASSIFIER_PCC_RESULT_NOT_YET) {
+		*process_response = pcci->process_response;
+		spin_unlock_bh(&ecm_classifier_pcc_lock);
+		ecm_db_connection_deref(ci);
+		return;
+	}
+
+	/*
+	 * If the destination port is to DNS server then we implicitly deny acceleration
+	 */
+	if (dst_port == 53) {
+		/*
+		 * By setting the permit state to DENIED we will always deny from this point on
+		 */
+		pcci->accel_permit_state = ECM_CLASSIFIER_PCC_RESULT_DENIED;
+		goto deny_accel;
+	}
+
+	/*
+	 * We need to call to the registrant BUT we cannot do this at a rate that exceeds 1/sec
+	 * NOTE: Not worried about wrap around, it's only one second.
+	 */
+	jiffies_now = jiffies;
+	if ((jiffies_now - pcci->process_jiffies_last) < HZ) {
+		/*
+		 * We cannot permit acceleration just yet
+		 * Deny accel but don't change the permit state - we try again later
+		 */
+		goto deny_accel;
+	}
+	pcci->process_jiffies_last = jiffies_now;
+
+	/*
+	 * We have to call out to our registrant to see if we can get permission to accelerate.
+	 * Get our registrant
+	 */
+	registrant = ecm_classifier_registrant;
+	registrant->ref(registrant);
+
+	/*
+	 * Bump reg calls made to the registrant.
+	 */
+	pcci->reg_calls_to++;
+
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+
+	/*
+	 * See if we can hold the registrant module - it may be unloading.
+	 */
+	if (!try_module_get(registrant->this_module)) {
+		/*
+		 * Module is unloading.
+		 */
+		registrant->deref(registrant);
+
+		/*
+		 * Force unregistration
+		 */
+		ecm_classifier_pcc_unregister_force(pcci);
+
+		/*
+		 * We are implicitly "not relevant".
+		 */
+		spin_lock_bh(&ecm_classifier_pcc_lock);
+		goto not_relevant;
+	}
+
+	/*
+	 * Ask the registrant if we may accelerate (big endian)
+	 */
+	ip_version = ecm_db_connection_ip_version_get(ci);
+	protocol = ecm_db_connection_protocol_get(ci);
+	ecm_db_connection_from_address_get(ci, src_ip);
+	src_port = htons(ecm_db_connection_from_port_get(ci));
+	dst_port = htons(dst_port);
+	ecm_db_connection_to_address_get(ci, dst_ip);
+	ecm_db_connection_from_node_address_get(ci, src_mac);
+	ecm_db_connection_to_node_address_get(ci, dest_mac);
+
+	/*
+	 * Default is permitted in case ip_version is unsupported here
+	 */
+	reg_result = ECM_CLASSIFIER_PCC_RESULT_PERMITTED;
+	if (ip_version == 4) {
+		__be32 src_ip4;
+		__be32 dest_ip4;
+
+		ECM_IP_ADDR_TO_NIN4_ADDR(src_ip4, src_ip);
+		ECM_IP_ADDR_TO_NIN4_ADDR(dest_ip4, dst_ip);
+		reg_result = registrant->okay_to_accel_v4(registrant, src_mac, src_ip4, src_port, dest_mac, dest_ip4, dst_port, protocol);
+	}
+	if (ip_version == 6) {
+		struct in6_addr src_ip6;
+		struct in6_addr dest_ip6;
+		ECM_IP_ADDR_TO_NIN6_ADDR(src_ip6, src_ip);
+		ECM_IP_ADDR_TO_NIN6_ADDR(dest_ip6, dst_ip);
+		reg_result = registrant->okay_to_accel_v6(registrant, src_mac, &src_ip6, src_port, dest_mac, &dest_ip6, dst_port, protocol);
+	}
+
+	/*
+	 * Release the ref taken for this call
+	 */
+	registrant->deref(registrant);
+
+	/*
+	 * Release the module ref taken.
+	 */
+	module_put(registrant->this_module);
+
+	/*
+	 * Handle the result
+	 */
+	switch (reg_result) {
+	case ECM_CLASSIFIER_PCC_RESULT_NOT_YET:
+		/*
+		 * Deny accel but don't change the permit state - we try again later
+		 */
+		spin_lock_bh(&ecm_classifier_pcc_lock);
+		goto deny_accel;
+	case ECM_CLASSIFIER_PCC_RESULT_DENIED:
+		/*
+		 * Deny accel and set the permit state to denied - this connection is denied from this point on.
+		 */
+		spin_lock_bh(&ecm_classifier_pcc_lock);
+		pcci->accel_permit_state = ECM_CLASSIFIER_PCC_RESULT_DENIED;
+		goto deny_accel;
+	case ECM_CLASSIFIER_PCC_RESULT_PERMITTED:
+		break;
+	default:
+		DEBUG_ASSERT(false, "Unhandled result: %d\n", reg_result);
+	}
+
+	/*
+	 * Acceleration is permitted
+	 */
+	spin_lock_bh(&ecm_classifier_pcc_lock);
+	pcci->accel_permit_state = ECM_CLASSIFIER_PCC_RESULT_PERMITTED;
+	pcci->process_response.relevance = ECM_CLASSIFIER_RELEVANCE_YES;
+	pcci->process_response.process_actions = ECM_CLASSIFIER_PROCESS_ACTION_ACCEL_MODE;
+	pcci->process_response.accel_mode = ECM_CLASSIFIER_ACCELERATION_MODE_ACCEL;
+	*process_response = pcci->process_response;
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+	ecm_db_connection_deref(ci);
+
+	return;
+
+not_relevant:
+
+	/*
+	 * ecm_classifier_pcc_lock MUST be held
+	 */
+	pcci->process_response.relevance = ECM_CLASSIFIER_RELEVANCE_NO;
+	pcci->process_response.process_actions = 0;
+	*process_response = pcci->process_response;
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+	ecm_db_connection_deref(ci);
+	return;
+
+deny_accel:
+
+	/*
+	 * ecm_classifier_pcc_lock MUST be held
+	 */
+	pcci->process_response.relevance = ECM_CLASSIFIER_RELEVANCE_YES;
+	pcci->process_response.process_actions = ECM_CLASSIFIER_PROCESS_ACTION_ACCEL_MODE;
+	pcci->process_response.accel_mode = ECM_CLASSIFIER_ACCELERATION_MODE_NO;
+	*process_response = pcci->process_response;
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+	ecm_db_connection_deref(ci);
+	return;
+
+}
+
+/*
+ * ecm_classifier_pcc_type_get()
+ *	Get type of classifier this is
+ */
+static ecm_classifier_type_t ecm_classifier_pcc_type_get(struct ecm_classifier_instance *aci)
+{
+	struct ecm_classifier_pcc_instance *pcci;
+	pcci = (struct ecm_classifier_pcc_instance *)aci;
+
+	DEBUG_CHECK_MAGIC(pcci, ECM_CLASSIFIER_PCC_INSTANCE_MAGIC, "%p: magic failed", pcci);
+	return ECM_CLASSIFIER_TYPE_PCC;
+}
+
+/*
+ * ecm_classifier_pcc_reclassify_allowed()
+ *	Get whether reclassification is allowed
+ */
+static bool ecm_classifier_pcc_reclassify_allowed(struct ecm_classifier_instance *aci)
+{
+	struct ecm_classifier_pcc_instance *pcci;
+	pcci = (struct ecm_classifier_pcc_instance *)aci;
+
+	DEBUG_CHECK_MAGIC(pcci, ECM_CLASSIFIER_PCC_INSTANCE_MAGIC, "%p: magic failed", pcci);
+	return true;
+}
+
+/*
+ * ecm_classifier_pcc_reclassify()
+ *	Reclassify
+ */
+static void ecm_classifier_pcc_reclassify(struct ecm_classifier_instance *aci)
+{
+	struct ecm_classifier_pcc_instance *pcci;
+	pcci = (struct ecm_classifier_pcc_instance *)aci;
+	DEBUG_CHECK_MAGIC(pcci, ECM_CLASSIFIER_PCC_INSTANCE_MAGIC, "%p: magic failed", pcci);
+
+	/*
+	 * Connection needs to be reset to 'as new'
+	 * NOTE: Implicitly the connection would have been decelerated now so we don't need to worry about that.
+	 */
+	spin_lock_bh(&ecm_classifier_pcc_lock);
+	pcci->accel_permit_state = ECM_CLASSIFIER_PCC_RESULT_NOT_YET;
+
+	/*
+	 * Reset jiffies for rate limiting registrant calls
+	 */
+	pcci->process_jiffies_last = jiffies;
+
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+}
+
+/*
+ * ecm_classifier_pcc_last_process_response_get()
+ *	Get result code returned by the last process call
+ */
+static void ecm_classifier_pcc_last_process_response_get(struct ecm_classifier_instance *aci,
+							struct ecm_classifier_process_response *process_response)
+{
+	struct ecm_classifier_pcc_instance *pcci;
+	pcci = (struct ecm_classifier_pcc_instance *)aci;
+	DEBUG_CHECK_MAGIC(pcci, ECM_CLASSIFIER_PCC_INSTANCE_MAGIC, "%p: magic failed", pcci);
+
+	spin_lock_bh(&ecm_classifier_pcc_lock);
+	*process_response = pcci->process_response;
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+}
+
+/*
+ * ecm_classifier_pcc_sync_to_v4()
+ *	Front end is pushing NSS state to us
+ */
+static void ecm_classifier_pcc_sync_to_v4(struct ecm_classifier_instance *aci, struct nss_ipv4_conn_sync *sync)
+{
+	struct ecm_classifier_pcc_instance *pcci __attribute__((unused));
+
+	pcci = (struct ecm_classifier_pcc_instance *)aci;
+	DEBUG_CHECK_MAGIC(pcci, ECM_CLASSIFIER_PCC_INSTANCE_MAGIC, "%p: magic failed", pcci);
+}
+
+/*
+ * ecm_classifier_pcc_sync_from_v4()
+ *	Front end is retrieving NSS state from us
+ */
+static void ecm_classifier_pcc_sync_from_v4(struct ecm_classifier_instance *aci, struct nss_ipv4_rule_create_msg *nircm)
+{
+	struct ecm_classifier_pcc_instance *pcci __attribute__((unused));
+
+	pcci = (struct ecm_classifier_pcc_instance *)aci;
+	DEBUG_CHECK_MAGIC(pcci, ECM_CLASSIFIER_PCC_INSTANCE_MAGIC, "%p: magic failed", pcci);
+}
+
+/*
+ * ecm_classifier_pcc_sync_to_v6()
+ *	Front end is pushing NSS state to us
+ */
+static void ecm_classifier_pcc_sync_to_v6(struct ecm_classifier_instance *aci, struct nss_ipv6_conn_sync *sync)
+{
+	struct ecm_classifier_pcc_instance *pcci __attribute__((unused));
+
+	pcci = (struct ecm_classifier_pcc_instance *)aci;
+	DEBUG_CHECK_MAGIC(pcci, ECM_CLASSIFIER_PCC_INSTANCE_MAGIC, "%p: magic failed", pcci);
+}
+
+/*
+ * ecm_classifier_pcc_sync_from_v6()
+ *	Front end is retrieving NSS state from us
+ */
+static void ecm_classifier_pcc_sync_from_v6(struct ecm_classifier_instance *aci, struct nss_ipv6_rule_create_msg *nircm)
+{
+	struct ecm_classifier_pcc_instance *pcci __attribute__((unused));
+
+	pcci = (struct ecm_classifier_pcc_instance *)aci;
+	DEBUG_CHECK_MAGIC(pcci, ECM_CLASSIFIER_PCC_INSTANCE_MAGIC, "%p: magic failed", pcci);
+}
+
+/*
+ * ecm_classifier_pcc_xml_state_get()
+ *	Return an XML state element
+ */
+static int ecm_classifier_pcc_xml_state_get(struct ecm_classifier_instance *ci, char *buf, int buf_sz)
+{
+	struct ecm_classifier_pcc_instance *pcci;
+	struct ecm_classifier_process_response process_response;
+	ecm_classifier_pcc_result_t accel_permit_state;
+	uint32_t reg_calls_to;
+	uint32_t reg_calls_from;
+	int count;
+	int total;
+
+	pcci = (struct ecm_classifier_pcc_instance *)ci;
+	DEBUG_CHECK_MAGIC(pcci, ECM_CLASSIFIER_PCC_INSTANCE_MAGIC, "%p: magic failed", pcci);
+
+	spin_lock_bh(&ecm_classifier_pcc_lock);
+	accel_permit_state = pcci->accel_permit_state;
+	process_response = pcci->process_response;
+	reg_calls_to = pcci->reg_calls_to;
+	reg_calls_from = pcci->reg_calls_from;
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+
+	count = snprintf(buf, buf_sz, "<ecm_classifier_pcc accel_permit_state=\"%d\" reg_calls_to=\"%u\" reg_calls_from=\"%u\">\n",
+			accel_permit_state,
+			reg_calls_to,
+			reg_calls_from);
+	if ((count <= 0) || (count >= buf_sz)) {
+		return -1;
+	}
+	total = count;
+	buf_sz -= count;
+
+	/*
+	 * Output our last process response
+	 */
+	count = ecm_classifier_process_response_xml_state_get(buf + total, buf_sz, &process_response);
+	if ((count <= 0) || (count >= buf_sz)) {
+		return -1;
+	}
+	total += count;
+	buf_sz -= count;
+
+	/*
+	 * Output our terminal element
+	 */
+	count = snprintf(buf + total, buf_sz, "</ecm_classifier_pcc>\n");
+	if ((count <= 0) || (count >= buf_sz)) {
+		return -1;
+	}
+	total += count;
+	return total;
+}
+
+/*
+ * ecm_classifier_pcc_instance_alloc()
+ *	Allocate an instance of the Parental Controls classifier
+ */
+struct ecm_classifier_pcc_instance *ecm_classifier_pcc_instance_alloc(struct ecm_db_connection_instance *ci)
+{
+	struct ecm_classifier_pcc_instance *pcci;
+	struct ecm_classifier_instance *cdi;
+
+	/*
+	 * Allocate the instance
+	 */
+	pcci = (struct ecm_classifier_pcc_instance *)kzalloc(sizeof(struct ecm_classifier_pcc_instance), GFP_ATOMIC | __GFP_NOWARN);
+	if (!pcci) {
+		DEBUG_WARN("Failed to allocate Parental Controls Classifier instance\n");
+		return NULL;
+	}
+
+	DEBUG_SET_MAGIC(pcci, ECM_CLASSIFIER_PCC_INSTANCE_MAGIC);
+	pcci->refs = 1;
+	pcci->ci_serial = ecm_db_connection_serial_get(ci);
+
+	/*
+	 * We are relevant to the connection at this time
+	 */
+	pcci->process_response.relevance = ECM_CLASSIFIER_RELEVANCE_YES;
+
+	/*
+	 * Don't know yet whether we are allowed to accelerate - need to query the registrant
+	 */
+	pcci->accel_permit_state = ECM_CLASSIFIER_PCC_RESULT_NOT_YET;
+
+	/*
+	 * Reset jiffies for rate limiting registrant calls
+	 */
+	pcci->process_jiffies_last = jiffies;
+
+	/*
+	 * Methods generic to all classifiers.
+	 */
+	cdi = (struct ecm_classifier_instance *)pcci;
+	cdi->process = ecm_classifier_pcc_process;
+	cdi->sync_from_v4 = ecm_classifier_pcc_sync_from_v4;
+	cdi->sync_to_v4 = ecm_classifier_pcc_sync_to_v4;
+	cdi->sync_from_v6 = ecm_classifier_pcc_sync_from_v6;
+	cdi->sync_to_v6 = ecm_classifier_pcc_sync_to_v6;
+	cdi->type_get = ecm_classifier_pcc_type_get;
+	cdi->reclassify_allowed = ecm_classifier_pcc_reclassify_allowed;
+	cdi->reclassify = ecm_classifier_pcc_reclassify;
+	cdi->last_process_response_get = ecm_classifier_pcc_last_process_response_get;
+	cdi->xml_state_get = ecm_classifier_pcc_xml_state_get;
+	cdi->ref = ecm_classifier_pcc_ref;
+	cdi->deref = ecm_classifier_pcc_deref;
+
+	/*
+	 * Increment stats
+	 */
+	spin_lock_bh(&ecm_classifier_pcc_lock);
+	ecm_classifier_pcc_count++;
+	DEBUG_ASSERT(ecm_classifier_pcc_count > 0, "%p: ecm_classifier_pcc_count wrap\n", pcci);
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+
+	DEBUG_INFO("Parental Controls classifier instance alloc: %p\n", pcci);
+	return pcci;
+}
+EXPORT_SYMBOL(ecm_classifier_pcc_instance_alloc);
+
+/*
+ * ecm_classifier_pcc_get_enabled()
+ *	Display enabled of classifier.
+ */
+static ssize_t ecm_classifier_pcc_get_enabled(struct device *dev,
+		  struct device_attribute *attr,
+		  char *buf)
+{
+	ssize_t count;
+	uint32_t num;
+
+	DEBUG_INFO("ecm_classifier_pcc_get_enabled\n");
+
+	spin_lock_bh(&ecm_classifier_pcc_lock);
+	num = (uint32_t)ecm_classifier_pcc_enabled;
+	spin_unlock_bh(&ecm_classifier_pcc_lock);
+
+	count = snprintf(buf, (ssize_t)PAGE_SIZE, "%u", num);
+	return count;
+}
+
+static DEVICE_ATTR(enabled, 0444, ecm_classifier_pcc_get_enabled, NULL);
+
+/*
+ * System device attribute array.
+ */
+static struct device_attribute *ecm_classifier_pcc_attrs[] = {
+	&dev_attr_enabled,
+};
+
+/*
+ * System device node the ECM Parental Controls classifier
+ * Sysdevice control points can be found at /sys/devices/system/ecm_classifier_pcc/ecm_classifier_pccX/
+ */
+static struct bus_type ecm_classifier_pcc_subsys = {
+	.name = "ecm_classifier_pcc",
+	.dev_name = "ecm_classifier_pcc",
+};
+
+/*
+ * ecm_classifier_pcc_dev_release()
+ *	This is a dummy release function for device.
+ */
+static void ecm_classifier_pcc_dev_release(struct device *dev)
+{
+
+}
+
+/*
+ * ecm_classifier_pcc_init()
+ */
+int ecm_classifier_pcc_init(void)
+{
+	int result;
+	int i;
+	DEBUG_INFO("Parental Controls classifier Module init\n");
+
+	/*
+	 * Initialise our global lock
+	 */
+	spin_lock_init(&ecm_classifier_pcc_lock);
+
+	/*
+	 * Register the Sub system
+	 */
+	result = subsys_system_register(&ecm_classifier_pcc_subsys, NULL);
+	if (result) {
+		DEBUG_ERROR("Failed to register sub system %d\n", result);
+		return result;
+	}
+
+	/*
+	 * Register System device control
+	 */
+	memset(&ecm_classifier_pcc_dev, 0, sizeof(ecm_classifier_pcc_dev));
+	ecm_classifier_pcc_dev.id = 0;
+	ecm_classifier_pcc_dev.bus = &ecm_classifier_pcc_subsys;
+	ecm_classifier_pcc_dev.release = &ecm_classifier_pcc_dev_release;
+	result = device_register(&ecm_classifier_pcc_dev);
+	if (result) {
+		DEBUG_ERROR("Failed to register System device %d\n", result);
+		goto classifier_task_cleanup_1;
+	}
+
+	/*
+	 * Create files, one for each parameter supported by this module
+	 */
+	for (i = 0; i < ARRAY_SIZE(ecm_classifier_pcc_attrs); i++) {
+		result = device_create_file(&ecm_classifier_pcc_dev, ecm_classifier_pcc_attrs[i]);
+		if (result) {
+			DEBUG_ERROR("Failed to register system device file %d\n", result);
+			goto classifier_task_cleanup_2;
+		}
+	}
+
+	return 0;
+
+classifier_task_cleanup_2:
+	while (--i >= 0) {
+		device_remove_file(&ecm_classifier_pcc_dev, ecm_classifier_pcc_attrs[i]);
+	}
+	device_unregister(&ecm_classifier_pcc_dev);
+classifier_task_cleanup_1:
+	bus_unregister(&ecm_classifier_pcc_subsys);
+
+	return result;
+}
+EXPORT_SYMBOL(ecm_classifier_pcc_init);
+
+/*
+ * ecm_classifier_pcc_exit()
+ */
+void ecm_classifier_pcc_exit(void)
+{
+	int i;
+	DEBUG_INFO("Parental Controls classifier Module exit\n");
+
+	for (i = 0; i < ARRAY_SIZE(ecm_classifier_pcc_attrs); i++) {
+		device_remove_file(&ecm_classifier_pcc_dev, ecm_classifier_pcc_attrs[i]);
+	}
+
+	device_unregister(&ecm_classifier_pcc_dev);
+	bus_unregister(&ecm_classifier_pcc_subsys);
+}
+EXPORT_SYMBOL(ecm_classifier_pcc_exit);
diff --git a/ecm_classifier_pcc.h b/ecm_classifier_pcc.h
new file mode 100644
index 0000000..e5f199a
--- /dev/null
+++ b/ecm_classifier_pcc.h
@@ -0,0 +1,18 @@
+/*
+ **************************************************************************
+ * Copyright (c) 2015, The Linux Foundation.  All rights reserved.
+ * Permission to use, copy, modify, and/or distribute this software for
+ * any purpose with or without fee is hereby granted, provided that the
+ * above copyright notice and this permission notice appear in all copies.
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
+ * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ **************************************************************************
+ */
+
+struct ecm_classifier_pcc_instance;
+struct ecm_classifier_pcc_instance *ecm_classifier_pcc_instance_alloc(struct ecm_db_connection_instance *ci);
diff --git a/ecm_classifier_pcc_public.h b/ecm_classifier_pcc_public.h
new file mode 100644
index 0000000..375cc49
--- /dev/null
+++ b/ecm_classifier_pcc_public.h
@@ -0,0 +1,69 @@
+/*
+ **************************************************************************
+ * Copyright (c) 2015, The Linux Foundation.  All rights reserved.
+ * Permission to use, copy, modify, and/or distribute this software for
+ * any purpose with or without fee is hereby granted, provided that the
+ * above copyright notice and this permission notice appear in all copies.
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
+ * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ **************************************************************************
+ */
+
+/*
+ * Structure used to synchronise a classifier instance with the state as presented by the NSS
+ */
+enum ecm_classifier_pcc_results {
+	ECM_CLASSIFIER_PCC_RESULT_NOT_YET,		/* Accel is neither permitted nor denied just yet - try again later */
+	ECM_CLASSIFIER_PCC_RESULT_DENIED,		/* Accel is denied for this connection */
+	ECM_CLASSIFIER_PCC_RESULT_PERMITTED,		/* Accel is permitted for this connection */
+};
+typedef enum ecm_classifier_pcc_results ecm_classifier_pcc_result_t;
+
+struct ecm_classifier_pcc_registrant;
+
+typedef void (*ecm_classifier_pcc_ref_method_t)(struct ecm_classifier_pcc_registrant *r);
+typedef void (*ecm_classifier_pcc_deref_method_t)(struct ecm_classifier_pcc_registrant *r);
+typedef ecm_classifier_pcc_result_t (*ecm_classifier_pcc_okay_to_accel_v4_method_t)(struct ecm_classifier_pcc_registrant *r, uint8_t *src_mac, __be32 src_ip, int src_port, uint8_t *dest_mac, __be32 dest_ip, int dest_port, int protocol);
+typedef ecm_classifier_pcc_result_t (*ecm_classifier_pcc_okay_to_accel_v6_method_t)(struct ecm_classifier_pcc_registrant *r, uint8_t *src_mac, struct in6_addr *src_ip, int src_port, uint8_t *dest_mac, struct in6_addr *dest_ip, int dest_port, int protocol);
+
+/*
+ * struct ecm_classifier_pcc_registrant
+ *	Used by customer parental control code to register their existance with the ECM PCC classifier
+ */
+struct ecm_classifier_pcc_registrant {
+	uint16_t version;					/* Customer Parental Controls (CPC) supplies 1 for this field. */
+
+	struct ecm_classifier_pcc_registrant *pcc_next;		/* ECM PCC use */
+	struct ecm_classifier_pcc_registrant *pcc_prev;		/* ECM PCC use */
+	uint32_t pcc_flags;					/* ECM PCC use */
+
+	atomic_t ref_count;					/* CPC sets this to 1 initially when registering with ECM.
+								 * PCC takes its own private 'ref' for the registrant so after registering the CPC should 'deref' the initial '1'.
+								 * CPC MUST NOT deallocate this structure until the ref_count is dropped to zero by deref() calls
+								 */
+	struct module *this_module;				/* Pointer to the registrants module */
+
+	ecm_classifier_pcc_ref_method_t ref;			/* When called the ref_count is incremented by 1 */
+	ecm_classifier_pcc_deref_method_t deref;		/* When called the ref_count is decremented by 1.
+								 * When ref_count becomes 0 no further calls will be made upon this registrant
+								 */
+	ecm_classifier_pcc_okay_to_accel_v4_method_t okay_to_accel_v4;
+								/* ECM PCC asks the CPC if the given connection is okay to accelerate */
+	ecm_classifier_pcc_okay_to_accel_v6_method_t okay_to_accel_v6;
+								/* ECM PCC asks the CPC if the given connection is okay to accelerate */
+};
+
+extern int ecm_classifier_pcc_register(struct ecm_classifier_pcc_registrant *r);
+extern void ecm_classifier_pcc_unregister_begin(struct ecm_classifier_pcc_registrant *r);
+
+extern void ecm_classifier_pcc_permit_accel_v4(uint8_t *src_mac, __be32 src_ip, int src_port, uint8_t *dest_mac, __be32 dest_ip, int dest_port, int protocol);
+extern void ecm_classifier_pcc_deny_accel_v4(uint8_t *src_mac, __be32 src_ip, int src_port, uint8_t *dest_mac, __be32 dest_ip, int dest_port, int protocol);
+
+extern void ecm_classifier_pcc_permit_accel_v6(uint8_t *src_mac, struct in6_addr *src_ip, int src_port, uint8_t *dest_mac, struct in6_addr *dest_ip, int dest_port, int protocol);
+extern void ecm_classifier_pcc_deny_accel_v6(uint8_t *src_mac, struct in6_addr *src_ip, int src_port, uint8_t *dest_mac, struct in6_addr *dest_ip, int dest_port, int protocol);
+
diff --git a/ecm_front_end_ipv4.c b/ecm_front_end_ipv4.c
index 584f58f..b2ffaa6 100644
--- a/ecm_front_end_ipv4.c
+++ b/ecm_front_end_ipv4.c
@@ -87,6 +87,9 @@
 #include "ecm_classifier_hyfi.h"
 #endif
 #include "ecm_classifier_dscp.h"
+#ifdef ECM_CLASSIFIER_PCC_ENABLE
+#include "ecm_classifier_pcc.h"
+#endif
 #include "ecm_interface.h"
 
 /*
@@ -4807,6 +4810,20 @@ static struct ecm_classifier_instance *ecm_front_end_ipv4_assign_classifier(stru
 	DEBUG_TRACE("%p: Assign classifier of type: %d\n", ci, type);
 	DEBUG_ASSERT(type != ECM_CLASSIFIER_TYPE_DEFAULT, "Must never need to instantiate default type in this way");
 
+#ifdef ECM_CLASSIFIER_PCC_ENABLE
+	if (type == ECM_CLASSIFIER_TYPE_PCC) {
+		struct ecm_classifier_pcc_instance *pcci;
+		pcci = ecm_classifier_pcc_instance_alloc(ci);
+		if (!pcci) {
+			DEBUG_TRACE("%p: Failed to create Parental Controls classifier\n", ci);
+			return NULL;
+		}
+		DEBUG_TRACE("%p: Created Parental Controls classifier: %p\n", ci, pcci);
+		ecm_db_connection_classifier_assign(ci, (struct ecm_classifier_instance *)pcci);
+		return (struct ecm_classifier_instance *)pcci;
+	}
+#endif
+
 #ifdef ECM_CLASSIFIER_NL_ENABLE
 	if (type == ECM_CLASSIFIER_TYPE_NL) {
 		struct ecm_classifier_nl_instance *cnli;
diff --git a/ecm_front_end_ipv6.c b/ecm_front_end_ipv6.c
index df83677..86df6ae 100644
--- a/ecm_front_end_ipv6.c
+++ b/ecm_front_end_ipv6.c
@@ -89,6 +89,9 @@
 #include "ecm_classifier_hyfi.h"
 #endif
 #include "ecm_classifier_dscp.h"
+#ifdef ECM_CLASSIFIER_PCC_ENABLE
+#include "ecm_classifier_pcc.h"
+#endif
 #include "ecm_interface.h"
 
 /*
@@ -5190,6 +5193,20 @@ static struct ecm_classifier_instance *ecm_front_end_ipv6_assign_classifier(stru
 	DEBUG_TRACE("%p: Assign classifier of type: %d\n", ci, type);
 	DEBUG_ASSERT(type != ECM_CLASSIFIER_TYPE_DEFAULT, "Must never need to instantiate default type in this way");
 
+#ifdef ECM_CLASSIFIER_PCC_ENABLE
+	if (type == ECM_CLASSIFIER_TYPE_PCC) {
+		struct ecm_classifier_pcc_instance *pcci;
+		pcci = ecm_classifier_pcc_instance_alloc(ci);
+		if (!pcci) {
+			DEBUG_TRACE("%p: Failed to create Parental Controls classifier\n", ci);
+			return NULL;
+		}
+		DEBUG_TRACE("%p: Created Parental Controls classifier: %p\n", ci, pcci);
+		ecm_db_connection_classifier_assign(ci, (struct ecm_classifier_instance *)pcci);
+		return (struct ecm_classifier_instance *)pcci;
+	}
+#endif
+
 #ifdef ECM_CLASSIFIER_NL_ENABLE
 	if (type == ECM_CLASSIFIER_TYPE_NL) {
 		struct ecm_classifier_nl_instance *cnli;
diff --git a/ecm_init.c b/ecm_init.c
index ec704b2..c298d5c 100644
--- a/ecm_init.c
+++ b/ecm_init.c
@@ -74,6 +74,11 @@ extern int ecm_classifier_dscp_init(void);
 extern void ecm_classifier_dscp_exit(void);
 #endif
 
+#ifdef ECM_CLASSIFIER_PCC_ENABLE
+extern int ecm_classifier_pcc_init(void);
+extern void ecm_classifier_pcc_exit(void);
+#endif
+
 /*
  * ecm_init()
  */
@@ -143,6 +148,13 @@ static int __init ecm_init(void)
 	}
 #endif
 
+#ifdef ECM_CLASSIFIER_PCC_ENABLE
+	ret = ecm_classifier_pcc_init();
+	if (0 != ret) {
+		goto err_cls_pcc;
+	}
+#endif
+
 	ret = ecm_interface_init();
 	if (0 != ret) {
 		goto err_iface;
@@ -188,6 +200,10 @@ err_bond:
 #endif
 	ecm_interface_exit();
 err_iface:
+#ifdef ECM_CLASSIFIER_PCC_ENABLE
+	ecm_classifier_pcc_exit();
+err_cls_pcc:
+#endif
 #ifdef ECM_CLASSIFIER_DSCP_ENABLE
 	ecm_classifier_dscp_exit();
 err_cls_dscp:
@@ -267,6 +283,11 @@ static void __exit ecm_exit(void)
 #endif
 	printk(KERN_INFO "exit interface\n");
 	ecm_interface_exit();
+
+#ifdef ECM_CLASSIFIER_PCC_ENABLE
+	printk(KERN_INFO "exit pcc classifier\n");
+	ecm_classifier_pcc_exit();
+#endif
 #ifdef ECM_CLASSIFIER_DSCP_ENABLE
 	printk(KERN_INFO "exit dscp classifier\n");
 	ecm_classifier_dscp_exit();
-- 
1.8.2

